- [HTTP request](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#body.HTTP_TEMPLATE)
- [Path parameters](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#body.PATH_PARAMETERS)
- [Query parameters](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#body.QUERY_PARAMETERS)
- [Request body](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#body.request_body)
- [Response body](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#body.response_body)
  - [JSON representation](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#body.TriggerActionResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#body.aspect)
- [TriggerActionPayload](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#TriggerActionPayload)
  - [JSON representation](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#TriggerActionPayload.SCHEMA_REPRESENTATION)
- [ActionInput](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#ActionInput)
  - [JSON representation](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#ActionInput.SCHEMA_REPRESENTATION)
- [InputValue](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#InputValue)
  - [JSON representation](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#InputValue.SCHEMA_REPRESENTATION)
- [TextInputValue](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#TextInputValue)
  - [JSON representation](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#TextInputValue.SCHEMA_REPRESENTATION)
- [ChoiceInputValue](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#ChoiceInputValue)
  - [JSON representation](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#ChoiceInputValue.SCHEMA_REPRESENTATION)
- [CheckboxInputValue](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#CheckboxInputValue)
  - [JSON representation](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#CheckboxInputValue.SCHEMA_REPRESENTATION)
- [Try it!](https://developers.google.com/merchant/api/reference/rest/issueresolution_v1/issueresolution/triggeraction.md.txt#try-it)

Start an action. The action can be requested by a business in third-party application. Before the business can request the action, the third-party application needs to show them action specific content and display a user input form. Access to the `triggeraction` method is restricted to an allowlist. You can submit an allowlist request in the [Shopping API Support Form](https://support.google.com/merchants/contact/shopping_api_support_form) under "What is the issue/question?" to get access to this feature.

The action can be successfully started only once all `required` inputs are provided. If any `required` input is missing, or invalid value was provided, the service will return 400 error. Validation errors will contain `Ids` for all problematic field together with translated, human readable error messages that can be shown to the user.

For more information, see [Display issues and solutions to businesses](https://developers.google.com/merchant/api/guides/accounts/render-issues.md.txt).

### HTTP request

`POST https://merchantapi.googleapis.com/issueresolution/v1/{name=accounts/*}:triggeraction`

The URL uses [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `name` | `string` Required. The business's account that is triggering the action. Format: `accounts/{account}` |

### Query parameters

| Parameters ||
|---|---|
| `languageCode` | `string` Optional. Language code [IETF BCP 47 syntax](https://tools.ietf.org/html/bcp47) used to localize the response. If not set, the result will be in default language `en-US`. |

### Request body

The request body contains an instance of `TriggerActionPayload`.

### Response body

Response informing about the started action.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "message": string } ``` |

| Fields ||
|---|---|
| `message` | `string` The message for the business. |

### Authorization scopes

Requires the following OAuth scope:

- `https://www.googleapis.com/auth/content`

For more information, see the [OAuth 2.0 Overview](https://developers.google.com/identity/protocols/OAuth2).

## TriggerActionPayload

The payload for the triggered action.

| JSON representation |
|---|
| ``` { "actionContext": string, "actionInput": { object (`ActionInput`) } } ``` |

| Fields ||
|---|---|
| `actionContext` | `string` Required. The `context` from the selected action. The value is obtained from rendered issues and needs to be sent back to identify the `action` that is being triggered. |
| `actionInput` | ``object (`ActionInput`)`` Required. Input provided by the business. |

## ActionInput

Input provided by the business.

| JSON representation |
|---|
| ``` { "actionFlowId": string, "inputValues": [ { object (`InputValue`) } ] } ``` |

| Fields ||
|---|---|
| `actionFlowId` | `string` Required. `Id` of the selected action flow. |
| `inputValues[]` | ``object (`InputValue`)`` Required. Values for input fields. |

## InputValue

Input provided by the business for input field.

| JSON representation |
|---|
| ``` { "inputFieldId": string, // The following is a list of mutually exclusive fields. At most one of the // fields will be set in a response: "textInputValue": { object (`TextInputValue`) }, "choiceInputValue": { object (`ChoiceInputValue`) }, "checkboxInputValue": { object (`CheckboxInputValue`) } // End of mutually exclusive fields. } ``` |

| Fields ||
|---|---|
| `inputFieldId` | `string` Required. `Id` of the corresponding input field. |
| Value provided by the business. The following is a list of mutually exclusive fields. At most one of the fields will be set in a response: ||
| `textInputValue` | ``object (`TextInputValue`)`` Value for `text input` field. |
| `choiceInputValue` | ``object (`ChoiceInputValue`)`` Value for `choice input` field. |
| `checkboxInputValue` | ``object (`CheckboxInputValue`)`` Value for `checkbox input` field. |
| End of mutually exclusive fields. ||

## TextInputValue

Value for `text input` field.

| JSON representation |
|---|
| ``` { "value": string } ``` |

| Fields ||
|---|---|
| `value` | `string` Required. Text provided by the business. |

## ChoiceInputValue

Value for `choice input` field.

| JSON representation |
|---|
| ``` { "choiceInputOptionId": string } ``` |

| Fields ||
|---|---|
| `choiceInputOptionId` | `string` Required. \[Id\]\[InputField.ChoiceInput.id\] of the option that was selected by the business. |

## CheckboxInputValue

Value for `checkbox input` field.

| JSON representation |
|---|
| ``` { "value": boolean } ``` |

| Fields ||
|---|---|
| `value` | `boolean` Required. True if the business checked the box field. False otherwise. |